// PythonIndentvOC indent.js
// @date 2010.10.24 syat v1.1
// @note ^Cvʐݒ[Cfg]Ƀ`FbNĉ

//J[\̂sԍ
var nCurLine = parseInt(Editor.ExpandParameter("$y"));
var nCurColumn = parseInt(Editor.ExpandParameter("$x"));
//^u
var nTabSize = Editor.ChangeTabWidth( 0 );
//Cfg̍쐬
var bTabIndent = Plugin.GetOption("Indent", "TabIndent") == 1 ? true : false;
var indentUnitSp = "";
for (var i=0; i<nTabSize; i++) {
	indentUnitSp += " ";
}
var indentUnit = "";
if (bTabIndent) {
	indentUnit = "\t";
} else {
	indentUnit = indentUnitSp;
}
//KwCfgFJ[\ʒuiCfgjɓKʂ̃Cfgo͂
//sCfgFu,v̎ŉsƂAɋ󔒂΍폜
var do_level_indent = false;	//KwCfgtO
var do_cr_indent = false;		//sCfgtO
var prev_indent = "####";		//OCfg
var chKey = Indent.GetChar();	//̓L[

//ҏW1sǂݍŉ͂
for ( var line_no = 1; line_no <= Editor.GetLineCount( 0 ) + 1; line_no++ ) {
	var line_str = Editor.GetLineStr( line_no );
	line_str = line_str.replace(/[\r\n]/g, "");			//s菜
	line_str = line_str.replace(/\t/g, indentUnitSp);	//^u͋󔒂ɕϊ

	//J[\sɗCfgďI
	if (line_no == nCurLine) {
		//TraceOut('level:'+do_level_indent.toString()+' cr:'+do_cr_indent.toString());
		if (do_level_indent && line_str == prev_indent) {
			Editor.InsText( indentUnit );
		} else if (do_cr_indent && chKey == '\r') {
			//J[\̎ɕsvȋ󔒂΍폜
			var cursor_right = line_str.substr(nCurColumn-1);
			var blank = cursor_right.replace(/^(\s+).*$/, "$1");
			if (blank.length != cursor_right.length) {
				Editor.WordDeleteToEnd()
			}
		}
		break;
	}

	prev_indent = line_str.replace(/^( *).*$/, "$1");

	do_level_indent = /^\s*(if|elif|else|for|while|try|except|finally|def|class)\b/.test(line_str);
	do_cr_indent = /,$/.test(line_str);
}
